# main.py
import machine
import time

SND_PIN = 14
DUTY = 512

tones = {
    "A0": 278, "AIS0": 29, "B0": 31,
    "C1": 33, "CIS1": 35, "D1": 37, "DIS1": 39, "E1": 41, "F1": 44,
    "FIS1": 46, "G1": 49, "GIS1": 52, "A1": 55, "AIS1": 58, "H1": 62,
    "C2": 65, "CIS2": 69, "D2": 73, "DIS2": 77, "E2": 82, "F2": 87,
    "FIS2": 92, "G2": 98, "GIS2": 104, "A2": 110, "AIS2": 116, "H2": 123,
    "C3": 130, "CIS3": 139, "D3": 147, "DIS3": 155, "E3": 165, "F3": 174,
    "FIS3": 185, "G3": 196, "GIS3": 207, "A3": 220, "AIS3": 233, "H3": 247,
    "C4": 261, "CIS4": 277, "D4": 293, "DIS4": 311, "E4": 330, "F4": 349,
    "FIS4": 369, "G4": 392, "GIS4": 415, "A4": 440, "AIS4": 466, "H4": 494
}
# TONE:n for n-length
# W to wait

ame2 = [
    "C2", "D2", "E2", "F2", "G2:2", "G2:2",
    "A2", "A2", "A2", "A2", "G2:2", "W",
    "A2", "A2", "A2", "A2", "G2:2", "W:2",
    "F2", "F2", "F2", "F2", "E2:2", "E2:2",
    "D2", "D2", "D2", "D2", "C2:2"
    ]
ame3 = [
    "C3", "D3", "E3", "F3", "G3:2", "G3:2",
    "A3", "A3", "A3", "A3", "G3:2", "W",
    "A3", "A3", "A3", "A3", "G3:2", "W:2",
    "F3", "F3", "F3", "F3", "E3:2", "E3:2",
    "D3", "D3", "D3", "D3", "C3:2"
    ]
ame4 = [
    "C4", "D4", "E4", "F4", "G4:2", "G4:2",
    "A4", "A4", "A4", "A4", "G4:2", "W",
    "A4", "A4", "A4", "A4", "G4:2", "W:2",
    "F4", "F4", "F4", "F4", "E4:2", "E4:2",
    "D4", "D4", "D4", "D4", "C4:2"
    ]


def play(pwm, pl):
    try:
        for k in pl:
            print(k)

            ks = k.split(":")
            t = ks[0]
            d = 1
            if len(ks) > 1:
                d = int(ks[1])
            if not t == "W":
                f = tones[t]
                pwm.duty(DUTY)
                pwm.freq(f)
            for i in range(d):
                time.sleep(0.2)

            pwm.duty(0)
            time.sleep(0.05)

    except Exception as ex:
        print(ex)
    finally:
        pwm.duty(0)

def main():
    snd = machine.Pin(SND_PIN)
    pwm = machine.PWM(snd)

    # play(pwm, ame2)
    # play(pwm, ame3)
    play(pwm, ame4)

if __name__ == "__main__":
    main()